<!DOCTYPE html>
<html>

<head>
    <title>Task 66 - Ward</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container-fluid pt-5">
        <div class="row form-group">
            <div class="col-1"></div>
            <div class="col-10 form-group jumbotron" style="border-style:groove">
                <h2 class="text-center">Phường, Xã</h2>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="ward" class="border-0 bg-transparent"><b>Tên</b><span
                                style="color:red">*</span></label>
                    </div>
                    <div class="col-8">
                        <input id="inp-ward" type="text" name="ward" placeholder="Add Ward" class="form-control border-primary">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="ward" class="border-0 bg-transparent"><b>Phường, Xã</b></label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-ward" class="form-control border-primary">
                            <option value="none">--Chọn--</option>
                            <option value="phuong">Phường</option>
                            <option value="xa">Xã</option>
                            <option value="thitran">Thị trấn</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="province" class="border-0 bg-transparent"><b>Tỉnh, Thành</b></label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-province" class="form-control border-primary">
                            <option value="none">--Chọn--</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="district" class="border-0 bg-transparent"><b>Quận, Huyện</b></label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-district" class="form-control border-primary" disabled>
                            <option value="none">--Chọn--</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="district" class="border-0 bg-transparent"><b>Id Phường, Xã</b></label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-id" class="form-control border-primary" disabled>
                            <option value="none">--Chọn Id (Trường hợp Edit và Delete)--</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-6"></div>
                    <div class="col-6 text-right">
                        <button class="btn btn-primary" id="add-ward">Add</button>
                        <button class="btn btn-success" id="edit-ward">Edit</button>
                        <button class="btn btn-danger" id="delete-ward">Delete</button>
                        <button class="btn btn-light" id="cancel-ward">Cancel</button>
                    </div>
                </div>
            </div>
            <div class="col-1"></div>
        </div>
    </div>

</body>
<script>
    $(document).ready(function() {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        onPageLoading();
        var gProvince = [];
        var gProvinceId = "";
        var gDistrict = [];
        var gDistrictId = "";
        var gWard = [];
        var gWardId;
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        // gán sự kiện change cho select province
        $('#select-province').on('change', function() {
            onBtnChangeProvinceSelect();
        });
        // gán sự kiện change cho select district
        $('#select-district').on('change', function() {
            onBtnChangeDistrictSelect();
        });
        // gán sự kiện change cho select Id Ward
        $('#select-id').on('change', function() {
            onBtnChangeIdWardSelect();
        });

        // gán sự kiện add cho nút Add Ward
        $('#add-ward').on('click', function() {
            onBtnAddWard();
        });
        // gán sự kiện add cho nút Edit Ward
        $('#edit-ward').on('click', function() {
            onBtnEditWard();
        });
        // gán sự kiện add cho nút Edit Ward
        $('#delete-ward').on('click', function() {
            console.log("bà mẹ nó chạy rồi")
            onBtnDeleteWard();
        });

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            "use strict";
            getAll()
        }

        function getAll() {
            $.ajax({
                url: "http://localhost:8080/province",
                type: "GET",
                dataType: 'json',
                async: false,
                success: function(responseObject) {
                    gProvince = responseObject;
                    console.log(gProvince);
                    loadDataIntoSelectProvince();
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }

        function loadDataIntoSelectProvince() {
            for (var bI = 0; bI < gProvince.length; bI++) {
                $('#select-province').append($('<option>', {
                    value: gProvince[bI].id,
                    text: gProvince[bI].name
                }));
            }
        }

        function loadDataIntoSelectIdDistrict() {
            for (var bI = 0; bI < gDistrict.length; bI++) {
                $('#select-district').append($('<option>', {
                    value: gDistrict[bI].id,
                    text: gDistrict[bI].name
                }));
            }
        }

        function loadDataIntoSelectIdWard() {
            for (var bI = 0; bI < gWard.length; bI++) {
                $('#select-id').append($('<option>', {
                    value: gWard[bI].id,
                    text: gWard[bI].id
                }));
            }
        }

        function onBtnAddProvince() {
            "use strict";
            var vProvinceObject = {
                name: "",
                code: ""
            }
            vProvinceObject.name = $("#inp-province").val().trim();
            vProvinceObject.code = $("#inp-code").val().trim();
            $.ajax({
                async: false,
                url: "http://localhost:8080/province",
                type: "POST",
                data: JSON.stringify(vProvinceObject),
                contentType: 'application/json;charset=UTF-8',
                success: function(res) {
                    console.log(res);
                    gProvince.push(res)
                    alert("Thêm Province thành công!");
                    pourFormDataIntoSelect();
                },
                error: function(error) {
                    alert(error.responseText);
                }
            });
        }

        // Hàm xử lý khi change select province
        function onBtnChangeProvinceSelect() {
            "use strict";
            var gProvinceId = $("#select-province").val(); // lấy ra provinceId từ select đc chọn
            console.log("vProvince được chọn: " + gProvinceId);
            if (gProvinceId != "none") {
                //Gọi APi theo provinceID
                $.ajax({
                    url: "http://localhost:8080/province/" + gProvinceId,
                    type: "GET",
                    dataType: 'json',
                    async: false,
                    success: function(res) {
                        console.log(res);
                        gDistrict = res.district;
                        $('#select-district').empty(); // Làm rỗng dữ liệu select district trước khi đổ dữ liệu vào
                        $('#select-district').removeAttr("disabled"); // Gỡ bỏ thuộc tính disabled
                        for (var bI = 0; bI < gDistrict.length; bI++) {
                            $('#select-district').append($('<option>', {
                                value: gDistrict[bI].id,
                                text: gDistrict[bI].name
                            }));
                        }
                    },
                    error: function(error) {
                        console.log(error.responseText);
                    }
                });
            } else {
                $('#select-district').attr("disabled", "disabled").empty().append($('<option>', {
                    value: "none",
                    text: "------"
                }));

            }
        }
        // Hàm xử lý khi change select district
        function onBtnChangeDistrictSelect() {
            "use strict";
            gDistrictId = $("#select-district").val(); // lấy ra provinceId từ select đc chọn
            console.log("District được chọn: " + gDistrictId);
            if (gProvinceId != "none") {
                //Gọi APi theo provinceID
                $.ajax({
                    url: "http://localhost:8080/district/" + gDistrictId,
                    type: "GET",
                    dataType: 'json',
                    async: false,
                    success: function(res) {
                        console.log(res);
                        gWard = res.ward;
                        $('#select-id').empty(); // Làm rỗng dữ liệu select district trước khi đổ dữ liệu vào
                        $('#select-id').removeAttr("disabled"); // Gỡ bỏ thuộc tính disabled
                        loadDataIntoSelectIdWard();
                    },
                    error: function(error) {
                        console.log(error.responseText);
                    }
                });
            } else {
                $('#select-id').empty().append($('<option>', {
                    value: "none",
                    text: "------"
                }));

            }
        }
        // Hàm xử lý khi change select Id Ward
        function onBtnChangeIdWardSelect() {
            "use strict";
            gWardId = $("#select-id").val(); // lấy ra provinceId từ select đc chọn
            console.log("Ward được chọn: " + gWardId);
            if (gWardId != "none") {
                //Gọi APi theo provinceID
                $.ajax({
                    url: "http://localhost:8080/ward/" + gWardId,
                    type: "GET",
                    dataType: 'json',
                    async: false,
                    success: function(res) {
                        console.log(res);

                        $("#inp-ward").val(res.name);
                        $('#select-ward option:selected').text(res.prefix)

                        // $('#select-ward').append($('<option>', {
                        //     //value: "---",
                        //     text: res.prefix
                        // })); // Làm rỗng dữ liệu select district trước khi đổ dữ liệu vào
                    },
                    error: function(error) {
                        console.log(error.responseText);
                    }
                });
            } else {
                $('#select-ward').empty().append($('<option>', {
                    value: "none",
                    text: "------"
                }));

            }
        }


        function onBtnAddWard() {
            "use strict";
            var vWardObject = {
                name: "",
                prefix: "",
            }
            vWardObject.name = $("#inp-ward").val().trim();
            vWardObject.prefix = $("#select-ward option:selected").text();
            var vDistrictId = $("#select-district").val();
            $.ajax({
                async: false,
                url: "http://localhost:8080/province/district/" + vDistrictId + "/ward",
                type: "POST",
                data: JSON.stringify(vWardObject),
                contentType: "application/json",
                success: function(res) {
                    console.log(res);
                    alert("Thêm Ward thành công!");
                    $("#inp-ward").val("");
                    $("#select-ward").val("none");
                    $("#select-province").val("none");
                    $("select-district").val("none");
                },
                error: function(error) {
                    alert(error.responseText);
                }
            });
        }

        function onBtnEditWard() {
            "use strict";
            console.log("nút edit được nhấn");
            var vWardObject = {
                name: "",
                prefix: "",
            }
            vWardObject.name = $("#inp-ward").val().trim();
            vWardObject.prefix = $("#select-ward option:selected").text();
            console.log(vWardObject);
            console.log("mã Ward" + gWardId);
            $.ajax({
                async: false,
                url: "http://localhost:8080/ward/" + gWardId,
                type: "PUT",
                data: JSON.stringify(vWardObject),
                contentType: 'application/json;charset=UTF-8',
                success: function(res) {
                    console.log(res);
                    gWard.push(res);
                    alert("Update Ward thành công!");
                    loadDataIntoSelectIdDistrict(gWard);
                    $("#inp-ward").val("");
                    $("#select-ward").val("none");
                    $("#select-province").val("none");
                    $("select-district").val("none");
                    $("select-id").val("none");
                },
                error: function(error) {
                    alert(error.responseText);
                }
            });
        }

        function onBtnDeleteWard() {
            "use strict";
            console.log(gWardId);
            $.ajax({
                async: false,
                url: "http://localhost:8080/ward/" + gWardId,
                type: "DELETE",
                data: 'json',
                success: function(res) {
                    alert("Xóa Ward thành công!");
                    $("#inp-ward").val("");
                    $("#select-ward").val("none");
                    $("#select-province").val("none");
                    $("select-district").val("none");
                    $("select-id").val("none");
                },
                error: function(error) {
                    alert(error.responseText);
                }
            })
        }

    });
</script>

</html>